package com.company.example.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;
import jakarta.persistence.*;
import jakarta.validation.constraints.NotNull;

@JmixEntity
@Table(name = "TRZ_INVENT_CLASSIFICATION", indexes = {
        @Index(name = "IDX_TRZ_INVENT_CLASSIFICATION_CLASSIFICATION", columnList = "CLASSIFICATION_ID")
}, uniqueConstraints = {
        @UniqueConstraint(name = "IDX_TRZ_INVENT_CLASSIFICATION_UNQ", columnNames = {"CLASSIFICATION_TYPE", "IDENTIFICATION", "TENANT_ID"})
})
@Entity(name = "trz_InventClassification")
public class InventClassification extends BasicField {

    @Column(name = "CLASSIFICATION_TYPE", nullable = false)
    @NotNull
    private Integer classificationType;

    @OnDeleteInverse(DeletePolicy.DENY)
    @JoinColumn(name = "CLASSIFICATION_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private InventClassification classification;

    public InventClassification getClassification() {
        return classification;
    }

    public void setClassification(InventClassification classification) {
        this.classification = classification;
    }

    public ClassificationType getClassificationType() {
        return classificationType == null ? null : ClassificationType.fromId(classificationType);
    }

    public void setClassificationType(ClassificationType classificationType) {
        this.classificationType = classificationType == null ? null : classificationType.getId();
    }

}